type 'a t

exception Empty

val empty : 'a t
(* the empty queue *)

val add : 'a -> 'a t -> 'a t
(* add x q returns a new queue containing the elements in q in the same order, followed by x at the end of the queue *)

val take : 'a t -> 'a t
(* take x q returns a new queue containing the elements in q in the same order except the one in front *)

val peek : 'a t -> 'a
(* peek q returns the element in front of q. Raises Empty if q is empty *)

val peek_opt : 'a t -> 'a option
(* peek_opt q returns Some x where x is the element in front of q if q is not empty or None if q is empty *)

val length : 'a t -> int
(* length q returns the number of elements in q. O(1) complexity *)
